<template>
  <v-menu
    v-model="menu"
    :close-on-content-click="false"
    :nudge-right="40"
    transition="scale-transition"
    offset-y
    min-width="290px"
  >
    <template #activator="{ on }">
      <XmlTextField
        v-model="value"
        :validate="validate"
        :label="label"
        :i18n="i18n"
        prepend-icon="event"
        readonly
        :wiki-entry="wikiEntry"
        v-on="on"
      />
    </template>
    <v-date-picker
      v-model="date"
      v-bind="$attrs"
      no-title
      scrollable
      :locale="$i18n.locale"
      :first-day-of-week="firstDayOfWeek"
      @input="menu = false"
    >
      <v-btn text color="error" @click="clearDate">
        {{ $t("form.clear") }}
      </v-btn>
    </v-date-picker>
  </v-menu>
</template>

<script>
import { DCCXMLElement } from "@d-ptb/dcc-js";
import XmlTextField from "./XmlTextField";

export default {
  name: "DccDatePicker",
  components: { XmlTextField },
  inheritAttrs: true,
  props: {
    value: Object,
    label: String,
    i18n: String,
    validate: String,
    wikiEntry: String,
  },
  data() {
    return {
      menu: false,
    };
  },
  computed: {
    date: {
      get() {
        return this.value ? this.value._text : "";
      },
      set(date) {
        if (date) {
          if (this.value) {
            this.value._text = date;
            this.$emit("input", this.value);
          } else {
            this.$emit(
              "input",
              new DCCXMLElement({
                _text: date,
              })
            );
          }
        } else {
          this.$emit("input", null);
        }
      },
    },
    firstDayOfWeek() {
      return parseInt(this.$t("lang.firstDayOfWeek"));
    },
  },
  methods: {
    clearDate() {
      this.date = "";
      this.menu = false;
    },
  },
};
</script>
